<template>
  <component
    v-bind:is="node.tag"
    :class="[node.id, node.type, node.parent_child_order, extra_css]" role="presentation">
    <template v-if="node.type">
      <div v-if="node.type === 'label' || node.type === 'heading'"
        v-bind:role="(node.type == 'heading') ? 'columnheader':'rowheader' ">
        <div class="table_label" :class="node.type" role="presentation">
          <span v-html="show_label(node)"></span>
          <div color="indigo-1" dense class="role" v-if="label_nice_role(node) !== 'label'">{{ label_nice_role(node) }}
          </div>
        </div>
      </div>
      <div v-if="node.type == 'context_heading'" role="columnheader">
        <span v-if="node.labels.length" v-html="show_label(node)"></span>
        <span v-else>
            {{ node.context_heading }}
          </span>
      </div>

      <div v-if="node.type == 'value'"
           v-on:click="show_node"
           @keypress.enter="show_node"
           class="click__me"
           tabindex="0"
           :title="'bekijk details: '+ get_label(node)"
           role="gridcell"
           :id="node.id">
      </div>
    </template>
    <template v-if="node.children && node.children.length">
      <TableNode v-for="(child, index) in node.children" v-bind:key="index" :node="child"
                 v-on:nodeClicked="nodeClicked">
      </TableNode>
    </template>
  </component>
</template>

<script>
import SharedMethods from "components/SharedMethods";
import CellValue from "components/CellValue";

export default {
  name: "TableNode",
  components: {CellValue},
  created() {
    this.label_nice_role = SharedMethods.label_nice_role
    this.get_label = SharedMethods.get_label
    this.show_label = SharedMethods.show_label
  },
  props: {
    node: undefined
  },
  computed: {
    extra_css: function () {
      if (this.node.children_first_css) {
        return "label__bottom"
      } else if (this.node.parent_child_order === 'children-first') {
        return "lift_me_up"
      }
      return ''
    }
  },
  methods: {
    show_node: function () {
      this.$emit('nodeClicked', this.node)
      Array.from(document.getElementsByClassName("choosen"))
        .forEach(el => {
          el.classList.remove("choosen")
        })
      document.getElementById(this.node.id).classList.add("choosen")
    },
    nodeClicked: function (node) {
      this.$emit('nodeClicked', node)
    }
  },
  emits: ["nodeClicked"]
}
</script>

<style scoped lang="scss">

td, th {
  border-bottom: 1px solid black;
  border-right: 1px solid black;
  padding: 2px 2px 2px 5px;
}

div.value {
  background: $blue-grey-1;
  min-width: 100px;
}

div.label .role,
div.heading .role {
  color: #222;
  font-style: italic;
  display: inline-block;
  background-color: $light-blue-1;
  padding: 1px 2px;
  font-weight: normal;
}

.heading .table_label,
.context_heading {
  font-weight: bold;
  text-align: center;
}

.label .table_label {
  font-weight: bold;
}

.click__me {
  width: 100%;
  height: 100%;
  cursor: pointer;
}

.choosen {
  background-color: $orange-11;
}

.label__bottom {
  display: flex;
  justify-content: flex-start;
  align-items: flex-end;
}

.lift_me_up {
  z-index: 1;
}

.z_divider {
  background-color: $orange-1;
}

.z_divider::after {
  content: "Z-axis";
  text-align: right;
  font-weight: bold;
  margin-left: 45%;
}
</style>
